local function SafeFreeSlot(...)
	for _,slot in ipairs({...})
		if not rawget(_G, slot) freeslot(slot) end -- Ensure we don't accidentally overlap existing freeslots
	end
end
local function SpawnCoins(mo, count)
	if count >= 500
		local coin = P_SpawnMobjFromMobj(mo,0,0,0,MT_WARIOLAND500COIN)
		mo.spawning = $ - 500
	elseif count >= 100
		local coin = P_SpawnMobjFromMobj(mo,0,0,0,MT_WARIOLAND100COIN)
		mo.spawning = $ - 100
	elseif count >= 50
		local coin = P_SpawnMobjFromMobj(mo,0,0,0,MT_WARIOLAND50COIN)
		mo.spawning = $ - 50
	elseif count >= 10
		local coin = P_SpawnMobjFromMobj(mo,0,0,0,MT_WARIOLAND10COIN)
		mo.spawning = $ - 10
	end
	if coin
		coin.angle = mo.angle-ANGLE_180
	end
end
if not srb2p
/* rawset(_G, "kombiwhogetswl4stuff", { -- Characters who get to have Wario Land 4 mechanics
	["kombi"] = true,
	["stryke"] = "wlsi",
	["trez"] = true,
}) */
rawset(_G, "kombiwhogetswl4stuff", { -- Characters who get to have Wario Land 4 mechanics
	["kombi"] = true,
	["shyne"] = "sms",
	["stryke"] = "wlsi",
	["trez"] = true,
})
rawset(_G, "coinlist", {
	[MT_BLUECRAWLA] = 20,
	[MT_REDCRAWLA] = 50,
	[MT_GFZFISH] = 20,
	[MT_GOLDBUZZ] = 40,
	[MT_REDBUZZ] = 80,
	[MT_JETTBOMBER] = 100,
	[MT_JETTGUNNER] = 100,
	[MT_CRAWLACOMMANDER] = 300,
	[MT_DETON] = 20,
	[MT_SKIM] = 40,
	[MT_POPUPTURRET] = 40,
	[MT_SPINCUSHION] = 50,
	[MT_CRUSHSTACEAN] = 50,
	[MT_BANPYURA] = 50,
	[MT_JETJAW] = 20,
	[MT_SNAILER] = 50,
	[MT_VULTURE] = 50,
	[MT_SPRINGSHELL] = 30,
	[MT_YELLOWSHELL] = 30,
	[MT_ROBOHOOD] = 50,
	[MT_FACESTABBER] = 300,
	[MT_UNIDUS] = 50,
	[MT_POINTY] = 40,
	[MT_CANARIVORE] = 30,
	[MT_PYREFLY] = 20,
	[MT_DRAGONBOMBER] = 50,
	[MT_EGGMOBILE] = 1000,
	[MT_EGGMOBILE2] = 1000,
	[MT_EGGMOBILE3] = 1000,
	[MT_EGGMOBILE4] = 1000,
	[MT_FANG] = 1000,
	[MT_CYBRAKDEMON] = 1000,
	[MT_METALSONIC_BATTLE] = 1000,
	[MT_GOOMBA] = 20,
	[MT_BLUEGOOMBA] = 20
})
SafeFreeSlot("sfx_wl4dmg","sfx_whurt0","sfx_whurt1","sfx_whurt2","sfx_whurt3","sfx_whurt4","sfx_whurt5","sfx_whurt6","sfx_whurt7","sfx_wltran",
"MT_WLHEALTHDISP","S_WARIDISP","sfx_wmhart","sfx_saring","sfx_saflik","SPR_WLHP","sfx_wllowh",
"S_WARIOLAND10COIN","MT_WARIOLAND10COIN","SPR_WLC1","sfx_wlcoi1",
"S_WARIOLAND50COIN","MT_WARIOLAND50COIN","SPR_WLC2","sfx_wlcoi2",
"S_WARIOLAND100COIN","MT_WARIOLAND100COIN","SPR_WLC3","sfx_wlcoi3",
"S_WARIOLAND500COIN","MT_WARIOLAND500COIN","SPR_WLC4","sfx_wlcoi4",
"S_KEYZERASLEEP","S_KEYZERAWAKE","MT_KEYZER","SPR_WLKI","sfx_keyzer","MT_KEYZERFOLLOW","S_KOMBIHIDE",
"sfx_saexpl")
sfxinfo[sfx_saexpl].caption = 'Pop'
end
// add another here to make it easier to debug X-Tra
/* freeslot("sfx_w1up",
"sfx_waow0","sfx_waow1","sfx_waow2","sfx_waow3","sfx_waow4","sfx_waow5","sfx_waow6","sfx_waow7","sfx_waow8","sfx_waow9","sfx_waow10","sfx_waow11",
"sfx_waow12","sfx_waow13","sfx_waow14","sfx_waow15","sfx_waow16","sfx_waow17") */

mobjinfo[MT_WARIOLAND500COIN] = {
spawnstate = S_WARIOLAND500COIN,
spawnhealth = 1000,
deathstate = S_WARIOLAND500COIN,
radius = mobjinfo[MT_RING].radius,
height = mobjinfo[MT_RING].height/2,
dispoffset = 4,
flags = MF_SCENERY|MF_SPECIAL,
}

states[S_WARIOLAND500COIN] = {
	sprite = SPR_WLC4,
	frame = FF_ANIMATE|A,
	tics = -1,
	var1 = 6,
	var2 = 2,
	nextstate = S_WARIOLAND500COIN,
}

mobjinfo[MT_WARIOLAND100COIN] = {
spawnstate = S_WARIOLAND100COIN,
spawnhealth = 1000,
deathstate = S_WARIOLAND100COIN,
radius = mobjinfo[MT_RING].radius,
height = mobjinfo[MT_RING].height/2,
dispoffset = 4,
flags = MF_SCENERY|MF_SPECIAL,
}

states[S_WARIOLAND100COIN] = {
	sprite = SPR_WLC3,
	frame = FF_ANIMATE|A,
	tics = -1,
	var1 = 5,
	var2 = 2,
	nextstate = S_WARIOLAND100COIN,
}

mobjinfo[MT_WARIOLAND50COIN] = {
spawnstate = S_WARIOLAND50COIN,
spawnhealth = 1000,
deathstate = S_WARIOLAND50COIN,
radius = mobjinfo[MT_RING].radius,
height = mobjinfo[MT_RING].height/2,
dispoffset = 4,
flags = MF_SCENERY|MF_SPECIAL,
}

states[S_WARIOLAND50COIN] = {
	sprite = SPR_WLC2,
	frame = FF_ANIMATE|A,
	tics = -1,
	var1 = 5,
	var2 = 2,
	nextstate = S_WARIOLAND50COIN,
}

mobjinfo[MT_WARIOLAND10COIN] = {
spawnstate = S_WARIOLAND10COIN,
spawnhealth = 1000,
deathstate = S_WARIOLAND10COIN,
radius = mobjinfo[MT_RING].radius,
height = mobjinfo[MT_RING].height/2,
dispoffset = 4,
flags = MF_SCENERY|MF_SPECIAL,
}

states[S_WARIOLAND10COIN] = {
	sprite = SPR_WLC1,
	frame = FF_ANIMATE|A,
	tics = -1,
	var1 = 3,
	var2 = 2,
	nextstate = S_WARIOLAND10COIN,
}

mobjinfo[MT_KEYZER] = {
spawnstate = S_KEYZERASLEEP,
spawnhealth = 1000,
deathstate = S_KEYZERASLEEP,
radius = mobjinfo[MT_TOKEN].radius/2,
height = mobjinfo[MT_TOKEN].height/2,
dispoffset = 0,
flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SPECIAL,
}

states[S_KEYZERASLEEP] = {
	sprite = SPR_WLKI,
	frame = FF_ANIMATE|A,
	tics = -1,
	var1 = 7,
	var2 = 6,
	nextstate = S_KEYZERASLEEP,
}

states[S_KEYZERAWAKE] = {
	sprite = SPR_WLKI,
	frame = FF_ANIMATE|I,
	tics = -1,
	var1 = 3,
	var2 = 6,
	nextstate = S_KEYZERAWAKE,
}

mobjinfo[MT_KEYZERFOLLOW] = {
spawnstate = S_KOMBIHIDE,
spawnhealth = 1000,
deathstate = S_KOMBIHIDE,
radius = mobjinfo[MT_TOKEN].radius/2,
height = mobjinfo[MT_TOKEN].height/2,
dispoffset = 0,
flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING,
}

states[S_KOMBIHIDE] = {
	sprite = SPR_NULL,
	frame = A,
	tics = -1,
	var1 = 0,
	var2 = 0,
	nextstate = S_KOMBIHIDE,
}

mobjinfo[MT_WLHEALTHDISP] = {
spawnstate = S_WARIDISP,
spawnhealth = 4,
deathstate = S_WARIDISP,
radius = mobjinfo[MT_PLAYER].radius/2,
height = mobjinfo[MT_PLAYER].radius/2,
dispoffset = 72,
flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING,
}

states[S_WARIDISP] = {
	sprite = SPR_WLHP,
	tics = -1,
	var1 = 0,
	var2 = 0,
	nextstate = S_WARIDISP,
}

rawset(_G, "cv_wl4hp", CV_RegisterVar({
	name = "k_wl4health",
	defaultvalue = "On",
	flags = CV_SAVE|CV_SHOWMODIF,
	PossibleValue = {On = 1, Off = 0},
}))

rawset(_G, "cv_wl4hurtdrop", CV_RegisterVar({
	name = "k_wl4hurtdrop",
	defaultvalue = 400,
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = CV_UNSIGNED,
}))

rawset(_G, "cv_kombiwl4max", CV_RegisterVar({
	name = "k_wl4maxhealth",
	defaultvalue = 8,
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = {MIN = 1, MAX = 64},
}))

rawset(_G, "cv_kombiwl4spawnhp", CV_RegisterVar({
	name = "k_wl4spawnhealth",
	defaultvalue = 0,
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = {MIN = 0, MAX = 64},
}))

rawset(_G, "cv_kombiwl4trans", CV_RegisterVar({
	name = "k_wl4transformations",
	defaultvalue = 0,
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = {On = 1, Off = 0},
}))

rawset(_G, "cv_kombiwlsihearts", CV_RegisterVar({
	name = "k_wlsimaxhearts",
	defaultvalue = 5,
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = {MIN = 1, MAX = 10},
}))

COM_AddCommand("k_addwl4char", function(player, arg1, arg2)
	if arg1 and skins[arg1]
		if arg2 and (arg2 == "wl4" or arg2 == "wlsi" or arg2 == "rblx" or arg2 == "sms")
			if arg2 == "wl4" kombiwhogetswl4stuff[arg1] = true else kombiwhogetswl4stuff[arg1] = arg2 end
		elseif not arg2
			CONS_Printf(player,"Did you forget to add a second argument?")
			CONS_Printf(player,"Defaulting to WL4...")
			kombihurryupchars[arg1] = true
		else
			CONS_Printf(player,"Something tells me you're trying to make that skin an invalid entry")
			CONS_Printf(player,"Defaulting to WL4...")
			kombihurryupchars[arg1] = true
		end
	elseif not arg1
		CONS_Printf(player,"Valid options: 'wl4', 'wlsi', 'rblx', 'sms'")
	else
		CONS_Printf(player,"I don't think you have that skin addon installed")
	end
end)


/// Passive Ability: Health System
// you have a health gauge instead of a ring gauge

if not srb2p
sfxinfo[sfx_wl4dmg].caption = 'Damage'
sfxinfo[sfx_whurt0].caption = '"No, no..."'
sfxinfo[sfx_whurt1].caption = '"No no..."'
sfxinfo[sfx_whurt2].caption = '"Oh boy..."'
sfxinfo[sfx_whurt3].caption = '"Oh boy..."'
sfxinfo[sfx_whurt4].caption = '"Grr... no, no..."'
sfxinfo[sfx_whurt5].caption = '"Hee hee hee hee hee hee!"'
sfxinfo[sfx_whurt6].caption = '"Yeah!"'
sfxinfo[sfx_whurt7].caption = '"Hey!"'
sfxinfo[sfx_wmhart].caption = 'Mini-Heart'
sfxinfo[sfx_saring].caption = 'Sparkle'
sfxinfo[sfx_saflik].caption = 'Animal Escaping'
sfxinfo[sfx_wlcoi1].caption = 'Small Coin'
sfxinfo[sfx_wlcoi2].caption = 'Bronze Coin'
sfxinfo[sfx_wlcoi3].caption = 'Silver Coin'
sfxinfo[sfx_wllowh].caption = '/'
sfxinfo[sfx_keyzer].caption = '/'
sfxinfo[sfx_wltran].caption = '/'
end

// CUSTOMIZE SECTION START
local skin = "kombi" // your character here
local shieldtake = true // if this is true, shield will be taken in exchange for health if you have one
local hitsound = sfx_wl4dmg // the sound that will play once your hit
// CUSTOMIZE SECTION END, PROCEED BELOW IF YOU KNOW WHAT YOU'RE DOING
local healthbar = 1
addHook("PlayerSpawn", function(player)
	player.hp = nil
	player.hpdivvies = nil
	player.kombimode = 0
	player.keyzerfollow = P_SpawnMobjFromMobj(player.realmo,0,0,0,MT_KEYZERFOLLOW)
	player.keyzerfollow.target = player.realmo
end)

addHook("PlayerThink", function(player)
	if not player.wl4score player.wl4score = 0 end
	if player.rblxouchclock
		player.rblxouchclock = $-1
	end
	if player.smswater == nil player.smswater = 100*FRACUNIT end
	if player.hp == nil and kombiwhogetswl4stuff[player.realmo.skin]
		if ultimatemode
			player.hpdivvies = 0
			player.hp = 1
		else
			if kombiwhogetswl4stuff[player.realmo.skin] == "wlsi"
				player.hp = cv_kombiwlsihearts.value*2
				player.hpdivvies = -32768
			elseif kombiwhogetswl4stuff[player.realmo.skin] == "sms"
				player.hp = 8
				player.hpdivvies = -32768
			else
				if (mapheaderinfo[gamemap].bonustype == 1)
					player.hp = cv_kombiwl4max.value
					player.hpdivvies = -32768
				else
					player.hpdivvies = 0
					player.hp = (cv_kombiwl4spawnhp.value or cv_kombiwl4max.value/2) or 1
				end
			end
		end
	end
	if player.rblxmaxhp == nil player.rblxmaxhp = 100 return end
	if player.rblxhp == nil or (player.rblxhp <= 0 and ((player.playerstate & PST_LIVE) or (player.playerstate & PST_REBORN)))
		player.rblxhp = player.rblxmaxhp*FRACUNIT
	end
	if not player.keyzerfollow
		player.keyzerfollow = P_SpawnMobjFromMobj(player.realmo,0,0,0,MT_KEYZERFOLLOW)
		player.keyzerfollow.target = player.realmo
	end
	if player.realmo and not kombiwhogetswl4stuff[player.realmo.skin] == "wlsi"
	and player.hp > cv_kombiwl4max.value
		player.hp = cv_kombiwl4max.value
	end
	if player.realmo and kombiwhogetswl4stuff[player.realmo.skin]
	and player.hpdivvies > 7
	and player.hp < cv_kombiwl4max.value
		player.hp = $ + 1
		player.hpdivvies = 0
	end
	if player.hpdivvies > 8
		player.hpdivvies = 8
	end
	if (maptol & TOL_NIGHTS)
		player.hp = 8
	end
end)

local actualhealth
local xpos
local ypos
local smsoffsets = {
	[8] = {18, 36},
	[7] = {12, 61},
	[6] = {19, 83},
	[5] = {37, 98},
	[4] = {63, 95},
	[3] = {68, 68},
	[2] = {70, 43},
	[1] = {65, 20},
	[9] = {48, 60},
	[10] = {49, 16},
}

-- FLUDD *should* use Cobalt
local function SMSunshineHUD(v,player)
	xpos = 265
	ypos = hudinfo[HUD_SCORE].y + 10
	local size = FRACUNIT/2
	local gain = (((leveltime%35)/23)%2)*FRACUNIT/6
	v.drawScaled((xpos+2)*FRACUNIT, (ypos+5)*FRACUNIT, FRACUNIT/2, v.cachePatch("SMSLIFEBG"), V_40TRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER, v.getColormap(player.realmo.skin, SKINCOLOR_ORANGE))
	v.drawScaled((xpos + (smsoffsets[9][1]/2))*FRACUNIT+(smsoffsets[9][1]%2*(FRACUNIT/2)), (ypos + (smsoffsets[9][2]/2))*FRACUNIT+(smsoffsets[9][2]%2*(FRACUNIT/2)), size+(gain/3), v.cachePatch("SMSLIFEMAINE"), V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
	if player.hp
		v.drawScaled((xpos + (smsoffsets[9][1]/2))*FRACUNIT+(smsoffsets[9][1]%2*(FRACUNIT/2)), (ypos + (smsoffsets[9][2]/2))*FRACUNIT+(smsoffsets[9][2]%2*(FRACUNIT/2)), size+(gain/3), v.cachePatch("SMSLIFEMAIN"), V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
		if player.hp < 8 v.drawScaled((xpos + (smsoffsets[9][1]/2))*FRACUNIT+(smsoffsets[9][1]%2*(FRACUNIT/2)), (ypos + (smsoffsets[9][2]/2))*FRACUNIT+(smsoffsets[9][2]%2*(FRACUNIT/2)), size+(gain/3), v.cachePatch("SMSLIFEMAIN"), ((player.hp+2)<<V_ALPHASHIFT)|V_REVERSESUBTRACT|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER) end
	end
	for i = 1, 8 do
		v.drawScaled((xpos + (smsoffsets[i][1]/2))*FRACUNIT+(smsoffsets[i][1]%2*(FRACUNIT/2)), (ypos + (smsoffsets[i][2]/2))*FRACUNIT+(smsoffsets[i][2]%2*(FRACUNIT/2)), size+gain, v.cachePatch("SMSLIFETICK\$i\E"), V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
		if player.hp >=i
			v.drawScaled((xpos + (smsoffsets[i][1]/2))*FRACUNIT+(smsoffsets[i][1]%2*(FRACUNIT/2)), (ypos + (smsoffsets[i][2]/2))*FRACUNIT+(smsoffsets[i][2]%2*(FRACUNIT/2)), size+gain, v.cachePatch("SMSLIFETICK\$i\"), V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
		end
	end
	v.drawScaled((xpos + (smsoffsets[10][1]/2))*FRACUNIT+(smsoffsets[10][1]%2*(FRACUNIT/2)), (ypos + (smsoffsets[10][2]/2))*FRACUNIT+(smsoffsets[10][2]%2*(FRACUNIT/2)), FRACUNIT/2, v.cachePatch("SMSLIFETEXT"), V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
	if player.hp < 8 v.drawScaled((xpos + (smsoffsets[10][1]/2))*FRACUNIT+(smsoffsets[10][1]%2*(FRACUNIT/2)), (ypos + (smsoffsets[10][2]/2))*FRACUNIT+(smsoffsets[10][2]%2*(FRACUNIT/2)), FRACUNIT/2, v.cachePatch("SMSLIFETEXT"), ((player.hp+2)<<V_ALPHASHIFT)|V_REVERSESUBTRACT|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER) end
	xpos = 265
	ypos = hudinfo[HUD_LIVES].y - 40
	gain = 0
	v.drawScaled((xpos+2)*FRACUNIT, (ypos+5)*FRACUNIT, FRACUNIT/2, v.cachePatch("SMSLIFEBG"), V_40TRANS|V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_PERPLAYER, v.getColormap(player.realmo.skin, SKINCOLOR_COBALT))
	v.drawFill((xpos+11), (ypos+40)-((player.smswater*30)/(100*FRACUNIT)), 5, (player.smswater*30)/(100*FRACUNIT), 131)
	v.drawFill((xpos+16), (ypos+40)-((player.smswater*30)/(100*FRACUNIT)), 16, (player.smswater*30)/(100*FRACUNIT), 133)
	xpos = 254
	ypos = hudinfo[HUD_SCORE].y + 50
end

local function RobloxHUD(v,player)
	xpos = 117
	ypos = 170
	v.draw(xpos, ypos, v.cachePatch("RBLXEDGE"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_FLIP)
	for i = 1,86 do
		v.draw(86+xpos-i, ypos, v.cachePatch("RBLXBACK"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
		if (player.rblxhp*86)/(player.rblxmaxhp*FRACUNIT) >= i
			if player.rblxhp*4 <= player.rblxmaxhp*FRACUNIT
				v.draw(86+xpos-i, ypos, v.cachePatch("RBLXTICK"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER, v.getColormap(player.realmo.skin, SKINCOLOR_RED))
			else
				v.draw(86+xpos-i, ypos, v.cachePatch("RBLXTICK"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER, v.getColormap(player.realmo.skin, SKINCOLOR_GREEN))
			end
		elseif player.rblxouch and (player.rblxouch*80)/(player.rblxmaxhp*FRACUNIT) >= i and player.rblxouchclock
			local whitefade = player.rblxouchclock-15
			print(whitefade)
			local redfade = 9-min(player.rblxouchclock,9)
			v.draw(86+xpos-i, ypos, v.cachePatch("RBLXOUCHTICK"), redfade<<V_ALPHASHIFT|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER, v.getColormap(player.realmo.skin, SKINCOLOR_RED))
			v.draw(86+xpos-i, ypos, v.cachePatch("RBLXOUCHTICK"), whitefade<<V_ALPHASHIFT|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER, v.getColormap(player.realmo.skin, SKINCOLOR_WHITE))
		end
	end
	v.draw(xpos+86, ypos, v.cachePatch("RBLXEDGE"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
	v.draw(xpos+86-1, ypos, v.cachePatch("RBLXTEXT"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
	xpos = 254
	ypos = hudinfo[HUD_SCORE].y + 12
end

local function WLShakeItHUD(v,player)
	xpos = 20
	for i = 1,cv_kombiwlsihearts.value do
		if player.hp/2 >= i
			healthbar = v.cachePatch("SHAKEHP2")
		else
			if player.hp%2 == 1 and (player.hp/2)+1 >= i
				healthbar = v.cachePatch("SHAKEHP1")
			else
				healthbar = v.cachePatch("SHAKEHP0")
			end
		end
		v.draw(xpos+i*10, ypos, healthbar, V_40TRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
	end
	xpos = 254
end

local function WL4HUD(v,player)
	actualhealth = player.hp+((player.powers[pw_shield] & SH_FIREFLOWER)>>9)+((player.powers[pw_shield] & SH_FORCE)>>8 + (min((player.powers[pw_shield] & SH_FORCEHP),(player.powers[pw_shield] & SH_FORCE))) or ((player.powers[pw_shield] & SH_WHIRLWIND)>>1 or (player.powers[pw_shield] & SH_PITY))) -- there's DEFINITELY a better way to do this
	local offset = ((8-min(max(actualhealth,cv_kombiwl4max.value),8))*4)
	local tickbar = v.cachePatch("TICKBAR\$player.hpdivvies\")
	xpos = $ + offset
	for i = 1,max(actualhealth,cv_kombiwl4max.value) do
		if player.hp >= i
			if actualhealth == 1 and ((leveltime + player.leveltimeadd) % 53 <= 24)
				healthbar = v.cachePatch("WARIOHPW")
			else
				healthbar = v.cachePatch("WARIOHPF")
			end
		else
			if actualhealth >= i
				if leveltime%2 == 0
					healthbar = v.cachePatch("WARIOHPF")
				else
					healthbar = v.cachePatch("WARIOHPE")
				end
			else
				healthbar = v.cachePatch("WARIOHPE")
			end
		end
		v.draw(xpos+(8*(((i-1)%8))), ypos-(((i-1)/8)*-8), healthbar, V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
	end
	xpos = $ - offset
	if not (mapheaderinfo[gamemap].levelflags & LF_WARNINGTITLE)
		ypos = $ + 7 + ((((max(actualhealth,cv_kombiwl4max.value)-1)/8))*8)
		v.draw(xpos, ypos, tickbar, V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER)
	end
end

hud.add(function(v,player)
		if player.realmo and kombiwhogetswl4stuff[player.realmo.skin]
		xpos = 254
		ypos = hudinfo[HUD_SCORE].y + 12
			if not srb2p
			if not (maptol & TOL_NIGHTS)
				if CV_FindVar("k_wl4health").string == "On"
					if kombiwhogetswl4stuff[player.realmo.skin] == "sms"
						SMSunshineHUD(v,player)
					elseif kombiwhogetswl4stuff[player.realmo.skin] == "rblx"
						RobloxHUD(v,player)
					elseif kombiwhogetswl4stuff[player.realmo.skin] == "wlsi"
						WLShakeItHUD(v,player)
					else
						WL4HUD(v,player)
					end
				end
			end
			end
			if player.mo and player.mo.skin == "kombi"
			local playnum = player.kombimode or 0
			local playtype = v.cachePatch("ABILSET\$playnum\")
			if ((player.pflags & PF_THOKKED) or not (not P_IsObjectOnGround(player.realmo) and (player.pflags & PF_JUMPED)))
				v.draw(xpos+32, ypos+8, playtype, V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER, v.getColormap(player.realmo.skin, player.realmo.color))
				v.draw(xpos+32, ypos+8, playtype, V_40TRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER, v.getColormap(player.realmo.skin, SKINCOLOR_BONE))
			else
				v.draw(xpos+32, ypos+8, playtype, V_HUDTRANS|V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER, v.getColormap(player.realmo.skin, player.realmo.color))
			end
			xpos = 117
			ypos = 180
			v.draw(xpos, ypos, v.cachePatch("RBLXEDGE"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_FLIP)
			for i = 1,86 do
				v.draw(86+xpos-i, ypos, v.cachePatch("RBLXBACK"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
			end
			for i = 1,(player.kombiboost*86)/(FRACUNIT) do
				if player.kombiboost*4 <= FRACUNIT
					v.draw(86+xpos-i, ypos, v.cachePatch("RBLXTICK"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER, v.getColormap(player.realmo.skin, SKINCOLOR_RED))
				else
					if i > 86
						v.draw(86+xpos-i, ypos, v.cachePatch("RBLXTICK"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER, v.getColormap(player.realmo.skin, (leveltime/5%79)+31))
					else
						v.draw(86+xpos-i, ypos, v.cachePatch("RBLXTICK"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER, v.getColormap(player.realmo.skin, player.realmo.color))
					end
				end
			end
			v.draw(xpos+86, ypos, v.cachePatch("RBLXEDGE"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
			v.draw(xpos+86-1, ypos, v.cachePatch("RBLXBOOSTTEXT"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER)
		end
	end
end)

addHook("PlayerThink", function(player)
	-- print(player.mo.momz)
	if player.tossdelay == 0 and player.mo.turns > 3
		player.mo.pause = 35
		player.mo.turns = 0
		player.mo.transformation = 0
	end
	if not player.realmo.transformation
		player.realmo.transformation = 0
	end
	if not player.leveltimeadd
		player.leveltimeadd = 0
	end
	if CV_FindVar("k_wl4health").string == "On"
		if (leveltime + player.leveltimeadd) % 53 == 0 and actualhealth == 1
			S_StartSound(player.mo, sfx_wllowh) -- I had to rip this myself. I really wish I didn't have to.
		end
	end
	if player.mo.transformation == 1
		if P_IsObjectOnGround(player.mo) and not player.mo.state == S_PLAY_RUN player.mo.state = S_PLAY_RUN end
		player.drawangle = player.mo.fireangle
		P_InstaThrust(player.mo,player.mo.fireangle,30*FRACUNIT)
	elseif player.mo.transformation == 2 and not P_IsObjectOnGround(player.mo)
		player.mo.z = $ - (P_GetMobjGravity(player.mo)/2)
	end
end)
/*
addHook("PreThinkFrame", do
	for player in players.iterate do
		if player.mo.transformation == 1
			player.cmd.forwardmove = 0
			player.cmd.sidemove = 0
		end
	end
end)
*/
addHook("ShouldDamage", function(target, inf, source, dmg, dmgType)
	if dmgType == DMG_CRUSHED
		if not target.transformation
			S_StartSound(target, P_RandomRange(sfx_whurt0,sfx_whurt7))
			S_StartSound(target, sfx_wltran)
			target.transformation = 2
		end
		return false
	end
end, MT_PLAYER)

addHook("MobjDamage", function(target, inf, src, dmg, dmgType)
	if dmgType == DMG_SPIKE and target.player.spinjumping and abs(target.momz) >= 3*FRACUNIT
		S_StartSound(target, sfx_kmwkik)
		P_SetObjectMomZ(target, -3*target.momz/4, false)
		return true
	end
	if kombiwhogetswl4stuff[target.skin] and not(target.player.powers[pw_super] or target.player.powers[pw_flashing])
	if dmgType == DMG_FIRE and cv_kombiwl4trans.value == 1 and inf and not inf.wl4notransform
		if not target.transformation
			S_StartSound(target, P_RandomRange(sfx_whurt0,sfx_whurt7))
			S_StartSound(target, sfx_wltran)
			target.fireangle = target.angle
			target.transformation = 1
		end
		return true
	end
	if not kombiwhogetswl4stuff[target.skin] == "rblx"
		S_StartSound(target, P_RandomRange(sfx_whurt0,sfx_whurt7))
	end
	target.spawning = min(CV_FindVar("k_wl4hurtdrop").value,target.player.wl4score)
	P_AddPlayerScore(target.player, target.spawning*-1) target.player.wl4score = $-target.spawning
	repeat
		SpawnCoins(target, target.spawning)
	until target.spawning < 10
	P_AddPlayerScore(target.player, target.spawning) target.player.wl4score = $+target.spawning -- do this to not scam people out of their score if spawning is not a multiple of 10
		if CV_FindVar("k_wl4health").string == "On"
			if kombiwhogetswl4stuff[target.skin] == "rblx"
				if not (dmgType & DMG_DEATHMASK) and target.player.instad and inf and not (inf.type and inf.type == MT_EGGMAN_ICON)
					if inf.player
						P_AddPlayerScore(inf.player, 50)
					end
				end
				if target.player.powers[pw_shield]
				and shieldtake == true
					target.player.powers[pw_flashing] = 50
					P_DoPlayerPain(target.player, src, inf)
					P_RemoveShield(target.player)
				else
					target.player.powers[pw_flashing] = 18
					target.player.timeshit = $+1
					P_PlayerEmeraldBurst(target.player,false)
					P_PlayerWeaponAmmoBurst(target.player)
					P_PlayerFlagBurst(target.player,false)
					local damage
					if inf != nil and inf.valid and FixedMul(inf.radius * 2, inf.height) / 20 > 0
						damage = max(1, FixedSqrt(FixedMul(inf.radius * 2, inf.height) / 20))
					else
						damage = 15*FRACUNIT
					end
					if damage >= 5*FRACUNIT
						if target.player.rblxouchclock
							target.player.rblxouchclock = 35
						else
							target.player.rblxouch = target.player.rblxhp
							target.player.rblxouchclock = 35
						end
					end
					target.player.rblxhp = $-damage
					if target.player.rblxhp <= 0
						P_KillMobj(target,inf,src)
					elseif target.player.hp == 1
						target.player.leveltimeadd = leveltime % 53
					end
				end
			elseif kombiwhogetswl4stuff[target.skin] == "wlsi"
				if not (dmgType & DMG_DEATHMASK) and target.player.instad and inf and not (inf.type and inf.type == MT_EGGMAN_ICON)
					if inf.player
						P_AddPlayerScore(inf.player, 50)
					end
				end
				if target.player.powers[pw_shield]
				and shieldtake == true
					target.player.powers[pw_flashing] = 50
					P_DoPlayerPain(target.player, src, inf)
					S_StartSound(target, hitsound)
					P_RemoveShield(target.player)
				else
					if inf != nil and inf.valid and FixedMul(inf.radius * 2, inf.height) / 200 > 0
						target.player.hp = $-max(1, FixedSqrt(FixedMul(inf.radius * 2, inf.height) / 200)/FRACUNIT)
					else
						target.player.hp = $-3
					end
					target.player.powers[pw_flashing] = 50
					P_DoPlayerPain(target.player, src, inf)
					S_StartSound(target, hitsound)
					P_PlayerEmeraldBurst(target.player,false)
					P_PlayerWeaponAmmoBurst(target.player)
					P_PlayerFlagBurst(target.player,false)
					if target.player.hp <= 0 and target.player.hpdivvies < 8
						P_KillMobj(target,inf,src)
					elseif target.player.hp == 1
						target.player.leveltimeadd = leveltime % 53
					end
				end
			elseif kombiwhogetswl4stuff[target.skin] == "sms"
				if not (dmgType & DMG_DEATHMASK) and target.player.instad and inf and not (inf.type and inf.type == MT_EGGMAN_ICON)
					if inf.player
						P_AddPlayerScore(inf.player, 50)
					end
				end
				if inf != nil and inf.valid and FixedMul(inf.radius * 2, inf.height) / 600 > 0
					print(FixedSqrt(FixedMul(inf.radius * 2, inf.height) / 600)/FRACUNIT)
					target.player.hp = $-max(1, FixedSqrt(FixedMul(inf.radius * 2, inf.height) / 600)/FRACUNIT)
				else
					target.player.hp = $-1
				end
				if (dmgType & DMG_ELECTRIC)
					target.player.powers[pw_flashing] = 135
					target.player.pause = 53
				else
					P_DoPlayerPain(target.player, src, inf)
				end
				target.player.timeshit = $+1
				S_StartSound(target, hitsound)
				P_PlayerEmeraldBurst(target.player,false)
				P_PlayerWeaponAmmoBurst(target.player)
				P_PlayerFlagBurst(target.player,false)
				if target.player.hp <= 0
					P_KillMobj(target,inf,src)
				elseif target.player.hp == 1
					target.player.leveltimeadd = leveltime % 53
				end
			else
				if not (dmgType & DMG_DEATHMASK) and target.player.instad and inf and not (inf.type and inf.type == MT_EGGMAN_ICON)
					if inf.player
						P_AddPlayerScore(inf.player, 50)
					end
				end
				if target.player.powers[pw_shield]
				and shieldtake == true
					target.player.powers[pw_flashing] = 50
					P_DoPlayerPain(target.player, src, inf)
					S_StartSound(target, hitsound)
					P_RemoveShield(target.player)
				else
					target.player.powers[pw_flashing] = 50
					target.player.hp = $ - 1
					P_DoPlayerPain(target.player, src, inf)
					S_StartSound(target, hitsound)
					P_PlayerEmeraldBurst(target.player,false)
					P_PlayerWeaponAmmoBurst(target.player)
					P_PlayerFlagBurst(target.player,false)
					if target.player.hp == 0 and target.player.hpdivvies < 8
						P_KillMobj(target,inf,src)
					elseif target.player.hp == 1
						target.player.leveltimeadd = leveltime % 53
					end
				end
			end
			return true
		end
	end
end, MT_PLAYER)

addHook("MobjDeath", function(target, inf, src, dmgType)
	/* if (dmgType & DMG_CRUSHED) and cv_kombiwl4trans.value == 1 and not mapheaderinfo[gamemap].kombi_wl4_noflat
		if target.transformation == 0
			S_StartSound(target, P_RandomRange(sfx_whurt0,sfx_whurt7))
			S_StartSound(target, sfx_wltran)
			target.transformation = 2
		end
		return true
	end */
	target.player.hp = 0
end, MT_PLAYER)

addHook("MobjThinker", function(mobj)
	A_CapeChase(mobj.target,1,0)
	if mobj.target.player
		local player = mobj.target.player
	end
	mobj.frame = player.hp
	print("Active!",mobj.x)
end, MT_WLHEALTHDISP)

addHook("MobjDeath", function(mo, inf, src)
		if not (mo.flags & MF_ENEMY) or not (src) or not (kombiwhogetswl4stuff[src.skin]) or not (src.player) then return end
		-- Don't check for console command in this function to not scam the player out of health if they decide to enable it again like the cowards they are
		if CV_FindVar("k_wl4health").string == "On" -- ...But we don't want to keep the auditory information despite this
			S_StartSound(mo, sfx_wmhart)
		end
		if src.skin == "kombi" src.player.kombiboost = $+FRACUNIT/32 end
		src.player.hpdivvies = $+1
		if src.player.hpdivvies > 7 -- do this to make places like the GHZ Armageddon Shield area give you the health it's supposed to
		and src.player.hp < cv_kombiwl4max.value
			src.player.hp = $ + 1
			src.player.hpdivvies = 0
		end
		mo.spawning = coinlist[mo.type] or 50
		repeat
			SpawnCoins(mo, mo.spawning)
		until mo.spawning < 10
	local type = mo.type
	if (src) and (src.player) and (kombiwhogetswl4stuff[src.skin]) and not ((type > MT_BUGGLE) and (type < MT_SPINBOBERT_FIRE2))
		and not ((type > MT_COIN) and (type <= MT_SHLEEP))
		and not (type == MT_FANG)
		local flickysfx = P_SpawnMobjFromMobj(mo,0,0,0,MT_THOK)
		flickysfx.tics,flickysfx.fuse = 60,60 flickysfx.flags2 = MF2_DONTDRAW flickysfx.spriteyscale = 1
		S_StartSound(flickysfx, sfx_saflik)
		S_StartSound(flickysfx, sfx_saexpl) -- should be available since X-Tra freeslots before we could potentially even do this
	
		if not mo.spawnedsaexplosion --Makes the mod stackable and modifyable. You can add it to a MobjSpawn hook for example.
		and not mo.player --...duh.
		
			mo.spawnedsaexplosion = true
			mo.flags2 = $|MF2_DONTDRAW
			mo.spritexscale,mo.spriteyscale = 1,1
		
			local expl = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SAEXPL)
			expl.scale = max(mo.scale, mo.height/32) --A bigger explosion the bigger you are!
			expl.target = mo
		end
	end
end)

local function CoinThinker(mobj)
	if mobj.collectwait > 0
		mobj.collectwait = $ - 1
	end
	mobj.scale = 2*FRACUNIT
end

local function CoinSpawn(mobj)
	if not ((mobj.flags2 & MF2_TWOD) or twodlevel)
		mobj.angle = FixedAngle(P_RandomRange(0, 359)*FRACUNIT)
	end
	P_Thrust(mobj, mobj.angle, 6*FRACUNIT)
	P_SetObjectMomZ(mobj, 12*FRACUNIT)
	mobj.collectwait = 13
end

local function WariYahoo(mobj)
	S_StartSound(mobj, P_RandomRange(sfx_waow0,sfx_waow18))
end

addHook("TouchSpecial", function(mobj,toucher) --I swear there's a way to pass custom arguments to these that i just don't know about
	if not kombiwhogetswl4stuff[toucher.skin] or mobj.collectwait then return true end
	P_AddPlayerScore(toucher.player, 10)
	toucher.player.wl4score = $+10
	S_StartSound(toucher, sfx_wlcoi1)
	mobj.state = S_NULL
end, MT_WARIOLAND10COIN)

addHook("TouchSpecial", function(mobj,toucher)
	if not kombiwhogetswl4stuff[toucher.skin] or mobj.collectwait then return true end
	P_AddPlayerScore(toucher.player, 50)
	toucher.player.wl4score = $+50
	S_StartSound(toucher, sfx_wlcoi2)
	mobj.state = S_NULL
end, MT_WARIOLAND50COIN)

addHook("TouchSpecial", function(mobj,toucher)
	if not kombiwhogetswl4stuff[toucher.skin] or mobj.collectwait then return true end
	P_AddPlayerScore(toucher.player, 100)
	toucher.player.wl4score = $+100
	S_StartSound(toucher, sfx_wlcoi3)
	mobj.state = S_NULL
end, MT_WARIOLAND100COIN)

addHook("TouchSpecial", function(mobj,toucher)
	if not kombiwhogetswl4stuff[toucher.skin] or mobj.collectwait then return true end
	P_AddPlayerScore(toucher.player, 500)
	toucher.player.wl4score = $+500
	S_StartSound(toucher, sfx_wlcoi4)
	mobj.state = S_NULL
end, MT_WARIOLAND500COIN)

addHook("MobjSpawn", CoinSpawn, MT_WARIOLAND10COIN)
addHook("MobjSpawn", CoinSpawn, MT_WARIOLAND50COIN)
addHook("MobjSpawn", CoinSpawn, MT_WARIOLAND100COIN)
addHook("MobjSpawn", CoinSpawn, MT_WARIOLAND500COIN)
addHook("MobjThinker", CoinThinker, MT_WARIOLAND10COIN)
addHook("MobjThinker", CoinThinker, MT_WARIOLAND50COIN)
addHook("MobjThinker", CoinThinker, MT_WARIOLAND100COIN)
addHook("MobjThinker", CoinThinker, MT_WARIOLAND500COIN)

addHook("MobjThinker", function(mobj)
	mobj.scale = 2*FRACUNIT
	if mobj.awake
		A_HomingChase(mobj,R_PointToDist2(mobj.x, mobj.y, mobj.target.x, mobj.target.y)/3,0)
	end
end, MT_KEYZER)

addHook("MobjThinker", function(mobj)
	if not mobj.target
		mobj.state = S_NULL
	else
		P_SetOrigin(mobj, mobj.target.x+(cos(mobj.target.player.drawangle)*-36), mobj.target.y+(sin(mobj.target.player.drawangle)*-36), mobj.target.z+FRACUNIT*40)
	end
end, MT_KEYZERFOLLOW)

addHook("MobjSpawn", function(mobj)
	mobj.awake = false
end, MT_KEYZER)

addHook("TouchSpecial", function(mobj,toucher)
	if not mobj.awake
		mobj.awake = true
		mobj.target = toucher.player.keyzerfollow or toucher
		mobj.state = S_KEYZERAWAKE
		token = $ + 1
		S_StartSound(mobj, sfx_keyzer)
		WariYahoo(toucher)
	end
	return true
end,MT_KEYZER)