// misc. section

local function SafeFreeSlot(...)
	for _,slot in ipairs({...})
		if not rawget(_G, slot) freeslot(slot) end -- Ensure we don't accidentally overlap existing freeslots
	end
end
SafeFreeSlot("sfx_kclear","sfx_kbossw","sfx_scaptr",
"MT_SAEXPL",
"SPR_SAEX","SPR_WLWE",  -- SAEX spawner is in WL4HP because i don't think i'd wanna write more hooks (proceeds to do it anyway)
"SKINCOLOR_SUPER_COBALT1", "SKINCOLOR_SUPER_COBALT2", "SKINCOLOR_SUPER_COBALT3", "SKINCOLOR_SUPER_COBALT4", "SKINCOLOR_SUPER_COBALT5",
"SKINCOLOR_COBALTSUPER",
"sfx_waow0","sfx_waow1","sfx_waow2","sfx_waow3","sfx_waow4","sfx_waow5","sfx_waow6","sfx_waow7","sfx_waow8","sfx_waow9","sfx_waow10",
"sfx_waow11","sfx_waow12","sfx_waow13","sfx_waow14","sfx_waow15","sfx_waow16","sfx_waow17","sfx_waow18","sfx_kmcbad","sfx_kcgood","sfx_kcbest")
SafeFreeSlot( -- Idle voice lines
"sfx_sidmr2",
"sfx_sidmr1",
"sfx_sidtp0",
"sfx_sidss2",
"sfx_sidss1",
"sfx_sidss3",
"sfx_sidss4",
"sfx_sidss5",
"sfx_sidfe1",
"sfx_sidfe2",
"sfx_sidlw1",
"sfx_sidlw2",
"sfx_sidsd3",
"sfx_sidsd2",
"sfx_sidsd1",
"sfx_sidrm1",
"sfx_sidrm2",
"sfx_sidsh3",
"sfx_sidsh2",
"sfx_sidsh1",
"sfx_sidtp2",
"sfx_sidtp1",
"sfx_sidic3",
"sfx_sidic2",
"sfx_sidic1",
"sfx_sidco2",
"sfx_sidco1",
"sfx_sidwv3",
"sfx_sidwv2",
"sfx_sidwv1",
"sfx_sidec2",
"sfx_sidec1",
"sfx_sidgen",
"sfx_sidsup",
"sfx_sidbo4",
"sfx_sidbo3",
"sfx_sidun4",
"sfx_sidun3",
"sfx_sidun2",
"sfx_sidun1",
"sfx_sidbo2",
"sfx_sidbo1",
"sfx_sidcg1",
"sfx_sidcg2",
"sfx_sidcg3",
"sfx_sidsh0",
"sfx_sideg2",
"sfx_sideg1",
"sfx_sidtik",
"sfx_sideg0",
"sfx_sidmr3"
)
sfxinfo[sfx_sidmr2].caption = "So, this is Angel Island!"
sfxinfo[sfx_sidmr1].caption = "It must get pretty lonely here..."
sfxinfo[sfx_sidmr1].caption = "I'm not too fond of places like this..."
sfxinfo[sfx_sidss2].caption = "Hey; hey! There\'s no time to rest!"
sfxinfo[sfx_sidss1].caption = "This station must be the center of the city!"
sfxinfo[sfx_sidss3].caption = "This makes me feel like a rat!"
sfxinfo[sfx_sidss4].caption = "There's no time for playing around!"
sfxinfo[sfx_sidss5].caption = "This area sure changed a lot!"
sfxinfo[sfx_sidfe1].caption = "Where does this end?"
sfxinfo[sfx_sidfe2].caption = "Just you wait, Robotnik!"
sfxinfo[sfx_sidlw1].caption = "It's mighty quiet here..."
sfxinfo[sfx_sidlw2].caption = "Where am I??"
sfxinfo[sfx_sidsd3].caption = "Hey, what's up with this ship?"
sfxinfo[sfx_sidsd2].caption = "Shoot, I hate this wind!"
sfxinfo[sfx_sidsd1].caption = "AAWHOAAA! I sure don't wanna fall off from here!"
sfxinfo[sfx_sidrm2].caption = "Whoa, that lava looks really, really hot!"
sfxinfo[sfx_sidrm1].caption = "Where did the Egg Carrier go?"
sfxinfo[sfx_sidsh3].caption = "The cars are so slow, they look like they're not moving!"
sfxinfo[sfx_sidsh3].caption = "Hey, there's no time to relax!"
sfxinfo[sfx_sidsh3].caption = "Time for some super sonic speed!"
sfxinfo[sfx_sidtp2].caption = "Looks like nobody's around."
sfxinfo[sfx_sidtp1].caption = "This must be the entrance to the bumper car area."
sfxinfo[sfx_sidic3].caption = "Watch and learn!"
sfxinfo[sfx_sidic2].caption = "Man, everything's frozen!"
sfxinfo[sfx_sidic1].caption = "'s getting cold!"
sfxinfo[sfx_sidco2].caption = "What's this smell? Smells like trash!"
sfxinfo[sfx_sidco1].caption = "Hmm, pinball!"
sfxinfo[sfx_sidwv3].caption = "Wow, it's pretty high up!"
sfxinfo[sfx_sidwv2].caption = "I'd better get outta here!"
sfxinfo[sfx_sidwv1].caption = "I can hear the wind in the distance!"
sfxinfo[sfx_sidec2].caption = "What a nice breeze!"
sfxinfo[sfx_sidec1].caption = "All I have to do is cruise this coast!"
sfxinfo[sfx_sidgen].caption = "Better get going!"
sfxinfo[sfx_sidsup].caption = "I'll show you what the Chaos Emeralds can really do!"
sfxinfo[sfx_sidbo4].caption = "You've had your fun; now it's MY turn!"
sfxinfo[sfx_sidbo3].caption = "Where can his weak spot be?"
sfxinfo[sfx_sidun4].caption = "I smell oil!"
sfxinfo[sfx_sidun3].caption = "So; that's his core!"
sfxinfo[sfx_sidun2].caption = "Not bad, not bad at all!"
sfxinfo[sfx_sidun1].caption = "Hey, this time you're not getting away!"
sfxinfo[sfx_sidbo2].caption = "You're no match for me!"
sfxinfo[sfx_sidbo1].caption = "He can't be invincible, can he?"
sfxinfo[sfx_sidcg1].caption = "Just remember, no fighting!"
sfxinfo[sfx_sidcg2].caption = "Yo, you guys been good?"
sfxinfo[sfx_sidcg3].caption = "What a peaceful place!"
sfxinfo[sfx_sidsh0].caption = "Shoot! I got sand in my eye!"
sfxinfo[sfx_sideg2].caption = "This ship is just too weird!"
sfxinfo[sfx_sideg2].caption = "This ship is too much!"
sfxinfo[sfx_sidtik].caption = "That's bad!"
sfxinfo[sfx_sideg0].caption = "This must be Robotnik's base!"
sfxinfo[sfx_sidmr3].caption = "Now THIS is more like it!"
-- Divisor lmao
sfxinfo[sfx_kclear].caption = "Yes!"
sfxinfo[sfx_kbossw].caption = "shit's too long lmao"
sfxinfo[sfx_scaptr].caption = 'Hey; let go!'
sfxinfo[sfx_waow0].caption = "Ya-hooooo!"
sfxinfo[sfx_waow1].caption = "Yahooo!"
sfxinfo[sfx_waow2].caption = "Ya-hoooo!"
sfxinfo[sfx_waow3].caption = "Ya-hoo!"
sfxinfo[sfx_waow4].caption = "Yahoo!"
sfxinfo[sfx_waow5].caption = "Hey, go!"
sfxinfo[sfx_waow6].caption = "Wow!"
sfxinfo[sfx_waow7].caption = "Wohhw!"
sfxinfo[sfx_waow8].caption = "Wow!"
sfxinfo[sfx_waow9].caption = "Ha, ha ha ha ha ha!"
sfxinfo[sfx_waow10].caption = "Hee, hee hee hee hee hee!"
sfxinfo[sfx_waow11].caption = "Ha ha- haa!!"
sfxinfo[sfx_waow12].caption = "Ha, ha ha ha ha!!"
sfxinfo[sfx_waow13].caption = "E-E-E-EXCLELLENT-E!"
sfxinfo[sfx_waow14].caption = "Excellent-e!"
sfxinfo[sfx_waow15].caption = "Excellent-e!"
sfxinfo[sfx_waow16].caption = "Alright!"
sfxinfo[sfx_waow17].caption = "Alright!"
sfxinfo[sfx_waow18].caption = "Wah!"

skincolors[SKINCOLOR_SUPER_COBALT1] = {
    name = "Super Cobalt 1",
    ramp = {0,0,0,0,144,144,145,146,147,148,151,153,156,157,157,157},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_COBALT2] = {
    name = "Super Cobalt 2",
    ramp = {0,0,144,145,147,148,149,150,152,154,156,157,157,158,158,158},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_COBALT3] = {
    name = "Super Cobalt 3",
    ramp = {144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_COBALT4] = {
    name = "Super Cobalt 4",
    ramp = {146,147,148,149,150,151,152,153,154,155,156,157,158,159,253,254},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_COBALT5] = {
    name = "Super Cobalt 5",
    ramp = {147,148,149,150,152,153,154,155,156,157,158,159,253,253,254,254},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_COBALTSUPER] = {
    name = "CobaltSuper",
    ramp = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    invcolor = SKINCOLOR_SANDY,
    invshade = 6,
    chatcolor = V_BLUEMAP,
    accessible = false
}

mobjinfo[MT_SAEXPL] = {
spawnstate = S_THOK,
deathsound = sfx_yusfxz,
flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOBLOCKMAP|MF_SCENERY|MF_NOGRAVITY
}
--Encompasses the intro... #PEAK!
--I swear I'd do the beginning cutscene but I'm not insane enough to do that... yet
local elapsed = 0
if not srb2p -- This isn't Wario Land 4-coded... BLOCKED!
	rawset(_G, "cv_kombiwl4titlescreen", CV_RegisterVar({ -- I'm the old SRB2! I want normal title screens!
	name = "k_wl4title",
	defaultvalue = "On",
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = {On = 1, Off = 0},
	}))
	hud.add(function(v, player)
		if cv_kombiwl4titlescreen.value
			elapsed = $+1
			v.draw(-128,-26,v.cachePatch("WL4TIBG1"))
			v.draw((elapsed/8)%512,0,v.cachePatch("WL4TIBG1"))
			v.draw(((elapsed/8)%512)-512,0,v.cachePatch("WL4TIBG1"))
			v.draw((elapsed/4)%512,46,v.cachePatch("WL4TIBG2"))
			v.draw(((elapsed/4)%512)-512,46,v.cachePatch("WL4TIBG2"))
			v.draw(((elapsed*5)%256)+128,130,v.cachePatch("WL4TIBG3"))
			v.draw(((elapsed*5)%256)-128,130,v.cachePatch("WL4TIBG3"))
			v.draw(((elapsed*5)%256)-384,130,v.cachePatch("WL4TIBG3"))
			v.draw(262,145,v.getSpritePatch(SPR_WLWE,A,0,FixedAngle(elapsed*12*FRACUNIT)),0)
			v.draw(180,112,v.cachePatch("WL4TCAR"))
			v.draw(208,145,v.getSpritePatch(SPR_WLWE,A,0,FixedAngle(elapsed*12*FRACUNIT)),0)
			if (-elapsed/10)+34 <= 0
				v.draw(0,0,v.cachePatch("WL4TITLE"),min(max(2^((((-elapsed)/10)+40)+15),65536),589824))
			elseif (-elapsed/10)+40 <= 0
				v.draw(0,0,v.cachePatch("WL4TITLE"))
			end
			-- print(min(max((-elapsed/10)-34<<V_ALPHASHIFT,1<<V_ALPHASHIFT),9<<V_ALPHASHIFT))
		end
	end, "title")
end

if not PlayerAnimInfo
	rawset(_G, "PlayerAnimInfo", {})
end

PlayerAnimInfo["kombi"] = {
		["runFrames"] = {0, 2},
		["dashFrames"] = {-1},
		["walkFrames"] = {3, 7},
		["waitFrames"] = {0},
		["milnekickFrames"] = {0, 4},
		["run"] = true,
		["dash"] = false,
		["walk"] = true,
		["idle"] = true,
		["wait"] = true,
		["milnekick"] = false,
		["superRun"] = true,
		["superDash"] = false,
		["superWalk"] = true,
		["superIdle"] = true,
		["superWait"] = true
}
if not solchars
	rawset(_G, "solchars", {})
end
solchars["kombi"] = {SKINCOLOR_SUPERGOLD1, 2}

rawset(_G, "cv_kombisuper", CV_RegisterVar({
	name = "k_supertheme",
	defaultvalue = "SA1",
	flags = CV_SAVE|CV_SHOWMODIF,
	PossibleValue = {SA1 = 0, SA2 = 1, SH = 2},
}))

rawset(_G, "cv_kombijingles", CV_RegisterVar({
	name = "k_jinglereplacements",
	defaultvalue = "SA1",
	flags = CV_SAVE|CV_SHOWMODIF,
	PossibleValue = {Off = 0, SA1 = 1, On = 1, SA2 = 2},
}))

local function WarioYahoo(player)
	S_StartSound(player, P_RandomRange(sfx_waow0,sfx_waow17))
end
/*
addHook("TouchSpecial", function(ring, toucher)
	if toucher and toucher.valid
	and kombiwhogetswl4stuff[toucher.player.realmo.skin] then
		S_StartSound(toucher, sfx_saring)
		P_SpawnMobj(ring.x, ring.y, ring.z, MT_SPARK)
		P_GivePlayerRings(toucher.player, 1)
		P_RemoveMobj(ring)
	end
end, MT_RING)

addHook("TouchSpecial", function(ring, toucher)
	if toucher and toucher.valid
	and toucher.player.realmo.skin == "kombi" then
		S_StartSound(toucher, sfx_saring)
		P_SpawnMobj(ring.x, ring.y, ring.z, MT_SPARK)
		P_GivePlayerRings(toucher.player, 1)
		P_RemoveMobj(ring)
	end
end, MT_FLINGRING)
*/

addHook("TouchSpecial", function(ring, toucher)
	if toucher and toucher.valid
		toucher.player.kombiboost = $+FRACUNIT/48
	end
end, MT_RING)

-- Roblox-styled health regeneration.

local REGEN_RATE = FixedDiv(FRACUNIT, FRACUNIT*100) -- Regenerate this fraction of MaxHealth per second.
local REGEN_STEP = 1*TICRATE -- Wait this long between each regeneration step.

--------------------------------------------------------------------------------

local function DoRobloxRegen(player)
	if not player.rblxhp or player.rblxhp < 1 return end
	if leveltime%REGEN_STEP == 0
		player.rblxhp = $+((FixedMul(player.rblxmaxhp*FRACUNIT, REGEN_RATE))*(REGEN_STEP/TICRATE))
	end
end

addHook("MobjSpawn", function(mo)
	mo.renderflags = RF_FULLBRIGHT|RF_NOCOLORMAPS
	mo.fuse,mo.tics = 25,40
	mo.sprite = SPR_SAEX
	mo.frame = A|FF_TRANS30
	mo.blendmode = AST_ADD
	mo.dispoffset = 99
end, MT_SAEXPL)

local exitingplus = 70

addHook("PlayerSpawn", function(player)
	player.alreadyextended = false
end)

rawset(_G, "cv_kombicamerapoint", CV_RegisterVar({
	name = "k_playerdeathfocus",
	defaultvalue = "On",
	flags = CV_SAVE|CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = {On = 1, Off = 0},
}))

/* savubg this here in the event i figure out i can prefix/suffix sounds
rawset(_G, "kombiidletalks", {
	["3 station square ss97"] = "SS0",
	["3 station square mrun"] = "MR1",
})
*/
rawset(_G, "kombiidletalks", { -- do mapnum AND track name alongside map name to be REALLY specific
	["vsboss"] = sfx_sidbo2, -- let's hope nobody decides any of these tracks are good level names??
	["vsalt"] = sfx_sidbo2,
	["vsfang"] = sfx_sidbo3,
	["vsmetl"] = sfx_sidbo1,
	["vsbrak"] = sfx_sidun1,
	["hurryu"] = sfx_sidwv2,
	["3 station square ss97"] = sfx_sidss1,
	["3 station square mrun"] = sfx_sidmr1,
	["greenflower zone 1"] = sfx_sidwv1,
	["greenflower zone 2"] = sfx_sidec2,
	["techno hill zone 1"] = sfx_sidss5,
	["techno hill zone 2"] = sfx_sidtp0,
	["deep sea zone 1"] = sfx_sidlw1,
	["deep sea zone 2"] = sfx_sidlw2,
	["castle eggman zone 1"] = sfx_sidss4,
	["castle eggman zone 2"] = sfx_sidsh2,
	["arid canyon zone 1"] = sfx_sidic3,
	["arid canyon zone 2"] = sfx_sidsh3,
	["red volcano zone 1"] = sfx_sidrm1,
	["egg rock zone 1"] = sfx_sidfe1,
	["egg rock zone 2"] = sfx_sidfe2,
	["black core zone 1"] = sfx_sidsh1,
})

addHook("PlayerThink", function(player)
	if not (player.cmd.buttons & BT_TOSSFLAG) and player.kombitossingflag
		local toplay = kombiidletalks[currentlyplaying] or kombiidletalks["\$gamemap\ \$string.lower(G_BuildMapTitle(gamemap))\ \$currentlyplaying\"] or kombiidletalks["\$gamemap\ \$string.lower(G_BuildMapTitle(gamemap))\"] or kombiidletalks["\$string.lower(G_BuildMapTitle(gamemap))\"] or kombiidletalks[currentlyplaying]
		if not toplay S_StartSound(player.mo, sfx_sidgen)
		elseif P_RandomRange(0,1)
			S_StopSoundByID(player.realmo, sfx_sidgen)
			S_StartSound(player.mo, toplay)
		else
			S_StopSoundByID(player.realmo, toplay)
			S_StartSound(player.mo, sfx_sidgen)
		end
		player.kombitossingflag = false
	elseif (player.cmd.buttons & BT_TOSSFLAG) and not player.kombitossingflag
		player.kombitossingflag = true
	end
	if player.powers[pw_carry] == 11 and player.realmo.skin == "kombi" and not player.kombipteracarried
		print(player.powers[pw_carry])
		S_StartSound(player.mo, sfx_scaptr)
		player.kombipteracarried = true
	elseif not player.powers[pw_carry] == 11
		player.kombipteracarried = false
	end
	elapsed = 0
	DoRobloxRegen(player)
	if player.rblxhp and player.rblxhp > player.rblxmaxhp*FRACUNIT player.rblxhp = player.rblxmaxhp*FRACUNIT end
	if player.realmo.skin == "kombi"
		if cv_kombicamerapoint.value
			if camera and (player.playerstate & PST_DEAD)
				//print(FixedInt(AngleFixed(camera.aiming)),FixedInt(player.mo.z),player.mo.skin,abs(player.realmo.momx) + abs(player.realmo.momy),player.normalspeed)
				local xy_calc = R_PointToDist2(camera.x, camera.y, player.mo.x, player.mo.y) -- horizontal angle
				local z_calc = player.mo.z - camera.z
				local vertical_calc = R_PointToAngle2(0, 0, xy_calc, z_calc) -- vertical angle
				camera.angle = xy_calc
				camera.aiming = vertical_calc
			elseif (player.playerstate & PST_DEAD)
				print("No camera to poll!")
			end
		end
		if player.exiting > 100
			player.exiting = $ - 1
		end
		if player.exiting > 0
			if not player.alreadyextended
				player.alreadyextended = true
				player.exiting = $ + exitingplus
			end
		end
		if player.exiting - exitingplus == 2 and player.alreadyextended
			if mapheaderinfo[gamemap].bonustype == 1
				S_StartSound(player.realmo, sfx_kbossw)
			else
				S_StartSound(player.realmo, sfx_kclear)
			end
			S_ChangeMusic("sacler", false, player)
		end
	end
end)
/*
hud.add(function()
	print("you're did it")
end, "intermission")
*/
addHook("MobjThinker", function(mo) 
	if not mo.valid or not mo.fuse return end
	if ((mo.frame & FF_FRAMEMASK) < P)
		mo.frame = $+1
		if mo.target and mo.target.valid --Stop an enemy's generic "pop" sounds.
			S_StopSoundByID(mo.target, sfx_pop)
		end
	end
	if (mo.fuse < 18)
		local TRANS = min(FF_TRANS90, 10<<16 - (mo.fuse/2)<<16 ) --Fading away!
		mo.frame = ($ & ~FF_TRANSMASK)|TRANS 
	end
end, MT_SAEXPL)

addHook("ThinkFrame", do
	skincolors[SKINCOLOR_COBALTSUPER].ramp = skincolors[SKINCOLOR_SUPER_COBALT1 + abs( ( (leveltime >> 1) % 9) - 4)].ramp
end)

/* addHook("PostThinkFrame", do
	for player in players.iterate
	local pollvar = player.aiming
	if pollvar
			print(pollvar)
		else
			print("No camera to poll!")
		end
	end
end) */

-- Why did I copy this? Am I lazy?
if not srb2p then return end
SafeFreeSlot("sfx_ebpsi","sfx_ebheal","sfx_ebpdie","sfx_ebphur","sfx_ebmort","sfx_ebitem","sfx_ebmiss","sfx_ebsmaa","sfx_ebhsta","sfx_ebpatk",
"sfx_ebdodg","sfx_eblear",
"sfx_ebfre1","sfx_ebfre2","sfx_ebfre3","sfx_ebehur","sfx_ebfla3","sfx_ebfir1","sfx_ebfir2")
-- Due to the exe nature of the mod, this only requires a one-time check.

-- Define our base character's stats!
charStats["kombi"] = {

		-- GENERAL

		name = "Kombi",		-- This is only for bots / enemies
		basehp = 90,			-- base HP for level 1 (Cannot be <= 0)
		basesp = 30,			-- base SP for level 1 (Can be 0, but not < 0!)
		persona = "kombi",		-- Persona to use
		melee_natk = "earthbound_bash",	-- normal melee attack
		wep = "hammer_01",
		weptype = WPT_HAMMER,

		-- Normal attack attributes
		-- Scales with game difficulty
		atk = 40,	-- power (generally < 50)
		acc = 95,	-- accuracy (%)
		crit = 2,	-- crit rate (%)

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, ["SPR2_CONST"]}
		-- (SPR2 must be a string, and is optional. Only for use with SPR_PLAY)

		-- Note: As of Beta 1.0.0, not all animations are implemented
		-- (* = unimplemented)

		anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},					-- standing
		anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_PLAY, A, 8, "SPR2_STND"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_PLAY, A, 1, "SPR2_GARD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, F, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, B, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 1, "SPR2_CNT1"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_PLAY, A, 1, "SPR2_CNT1"},					-- is down
		anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_PAIN"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, D, 1, "SPR2_ROLL"},			-- gets revived

		-- anim_special1 through anim_special32 may also be used for various purposes (ie: attack animations)
		anim_special1 =	{SPR_PLAY, A, 2, "SPR2_MLEE"},
		anim_special2 = {SPR_PLAY, B, C, D, 2, "SPR2_MLEE"}, -- hammer swing
		anim_special3 = {SPR_PLAY, A, "SPR2_MLEE"},	-- hammer swung
		anim_special4 = {SPR_PLAY, A, B, C, D, E, "SPR2_TWIN"},	-- hammer spin

		-- VOICES
		-- Possible list of voices
		-- vfx_action = {"sfx_voice1", "sfx_voice2", [...], "sfx_voicen"}

		-- ...In the case of kanade, she's silent, but I will leave these here for reference!

		vfx_summon = {},	-- Summoning Persona to use a Skill
        vfx_skill = {},		-- Used a Skill
        vfx_item = {"sfx_ebitem"},		-- Used an item
        vfx_hurt = {"sfx_ebphur"},		-- Sustained damage
        vfx_hurtx = {"sfx_ebmort"},		-- Sustained heavy damage / Critical hit / Weakness
        vfx_die = {"sfx_ebpdie"},		-- Death
        vfx_heal = {},		-- Healed by teammate
        vfx_healself = {},	-- Healed self
        vfx_kill = {},		-- Killed an enemy
        vfx_1more = {},		-- Performed 1more
        vfx_crit = {},		-- Cut-in for Weakness/Critical Hit
        vfx_aoaask = {},	-- Ask to All-Out Attack
        vfx_aoado = {},		-- Performing All-Out Attack
        vfx_aoarelent = {},	-- Relenting from All-Out Attack
        vfx_miss = {"sfx_ebmiss"},		-- Missed attack
        vfx_dodge = {"sfx_ebdodg"},		-- Dodged enemy attack
        vfx_win = {},		-- Battle won
        vfx_levelup = {"sfx_eblear"},	-- Level Up!


		-- HUD DEFINTIIONS

		icon = "ICO_KMBI",			-- head icon for character select
		hudbust = "H_KOMBAR",			-- patch to draw on the stat hud
		hudaoa = "H_KOMAOA",		-- patch for all out attack hud
		hudcutin = "KANA_A",		-- cut in frames prefix

		-- Tip to display on the character select.
		-- Give insight on their skill type and their strengths/weaknesses in battle!
		tip = "oughhh i'm over here bounding my earth",
}

personaList["kombi"] = {
		-- GENERAL
		name = "Kombi",	-- Name of the Persona
		arcana = nil,			-- Arcana (unused in Beta 1.0.0, can be left nil as well)

		sprite = SPR_PSN0,		-- Unused outside of debugging purposes for shortcuts. Can be left nil
		startframe = 0,			-- Unused outside of debugging purposes for shortcuts. Can be left nil

		-- Animations function the same way they do for players. (In Kanade's case, she's so good she doesn't need one, so let's make it invisible)
		anim_idle = 	{SPR_NULL, A},	-- Idle animation when summoned in the menu
		anim_atk = 		{SPR_NULL, A},	-- Animation when attacking

		-- Stats (at level 10)
		-- Remember that stats naturally cap at 99.
		strength = 12,
		magic = 7,
		endurance = 7,
		luck = 4,
		agility = 10,

		-- Affinities (weak, resist, block, drain)
		weak = ATK_CURSE,
		resist = ATK_SLASH|ATK_BLESS,
		block = ATK_PIERCE,

		/*Skills learnt and their level:
			{
				{"skillname", level, ["skill_to_replace"]},
				{"skill2name", level, ["skill_to_replace"]},
				[...]
			}

			Documentation for every existing skill name will be available publically at a later date.
			For now, feel free to scout the game files yourself!

			the 3rd argument is only useful on higher difficulties where characters automatically start at
			higher levels, meaning their skills need to be automatically replaced.

			NOTE: Characters can only have 8 skills total! But if you mess this up, the game won't stop you from having 69 skills.
			So pay attention!
		*/

		skills = {
					{"lifeup1", 2}, {"rockin1", 8},
					{"healing2", 15}, {"shield1", 12},
					{"lifeup4", 70}, {"fire1", 3},
					{"freeze1", 1}, {"thunder1", 8},
					
					{"fire2", 19, "fire1"},
					{"fire3", 37, "fire2"},
					{"fire4", 64, "fire3"},
					
					{"freeze2", 11, "freeze1"},
					{"freeze3", 31, "freeze2"},
					{"freeze4", 46, "freeze3"},
					
					{"thunder2", 15, "thunder1"},
					{"thunder3", 41, "thunder2"},
					{"thunder4", 55, "thunder3"},
					
					{"lifeup2", 15, "lifeup1"},
					{"lifeup3", 39, "lifeup2"},
					
					{"rockin2", 22, "rockin1"},
					{"rockin3", 49, "rockin2"},
					{"rockin4", 75, "rockin3"},
				},
}

-- Finally, let us define our additional skills.

attackDefs["earthbound_bash"] = {
	name = "Bash",
	type = ATK_STRIKE,
	power = 45,
	accuracy = 85,
	critical = 7, -- was 7
	target = TGT_ENEMY,
	costtype = CST_HP,
	cost = 0,
	desc = "A strong Hammer Hit.",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	anim = 	function(mo, targets, hittargets, timer)
				local target = targets[1]
				if timer == 1
					ANIM_set(mo, mo.anim_special1, true)
					playSound(mo.battlen, sfx_ebpatk)

					-- fake A_LobShot:
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

					local z = mo.z
					local hit = P_SpawnMobj(target.x & (64*FRACUNIT -1), target.y & (64*FRACUNIT -1), target.subsector.sector.floorheight, MT_NULL)
					hit.tics = TICRATE

					local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
					local horizontal = dist / TICRATE
					local vertical = FixedMul((gravity*TICRATE)/2, mo.scale)

					mo.momx = FixedMul(horizontal, cos(mo.angle))
					mo.momy = FixedMul(horizontal, sin(mo.angle))
					mo.momz = vertical


					-- move camera to an interresting spot

					local an = target.angle + 45*ANG1

					local cx = target.x + 384*cos(an)
					local cy = target.y + 384*sin(an)

					CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
					CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
					--CAM_aiming(server.P_BattleStatus[mo.battlen].cam, -ANG1*10, ANG1)

				elseif timer == TICRATE - 7
					ANIM_set(mo, mo.anim_special2)	-- hammer hit prep

				elseif timer == TICRATE
					playSound(mo.battlen, sfx_ebehur)
					damageObject(hittargets[1])
					P_InstaThrust(mo, 0, 0)

					-- explode hearts all over!
					-- heart ring:
					for i = 1, 8
						local h = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						h.state = S_LHRT
						h.fuse = TICRATE
						P_InstaThrust(h, (360/8 *i)*ANG1, FRACUNIT*32)
					end

					localquake(mo.battlen, FRACUNIT*30, 8)
					playSound(mo.battlen, sfx_pstop)

					for i = 1, 16
						local h = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						h.state = S_LHRT
						h.fuse = TICRATE
						h.momx = P_RandomRange(-24, 24)*FRACUNIT
						h.momy = P_RandomRange(-24, 24)*FRACUNIT
						h.momz = P_RandomRange(2, 24)*FRACUNIT
					end
				elseif timer == TICRATE*2
					return true
				end
			end,
	critanim = 	function(mo, targets, hittargets, timer)
				local target = targets[1]
				if timer == 1
					ANIM_set(mo, mo.anim_special1, true)
					playSound(mo.battlen, sfx_ebpatk)

					-- fake A_LobShot:
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

					local z = mo.z
					local hit = P_SpawnMobj(target.x & (64*FRACUNIT -1), target.y & (64*FRACUNIT -1), target.subsector.sector.floorheight, MT_NULL)
					hit.tics = TICRATE

					local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
					local horizontal = dist / TICRATE
					local vertical = FixedMul((gravity*TICRATE)/2, mo.scale)

					mo.momx = FixedMul(horizontal, cos(mo.angle))
					mo.momy = FixedMul(horizontal, sin(mo.angle))
					mo.momz = vertical


					-- move camera to an interresting spot

					local an = target.angle + 45*ANG1

					local cx = target.x + 384*cos(an)
					local cy = target.y + 384*sin(an)

					CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
					CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
					--CAM_aiming(server.P_BattleStatus[mo.battlen].cam, -ANG1*10, ANG1)

				elseif timer == TICRATE - 7
					ANIM_set(mo, mo.anim_special2)	-- hammer hit prep

				elseif timer == TICRATE
					playSound(mo.battlen, sfx_ebsmaa)
					damageObject(hittargets[1])
					P_InstaThrust(mo, 0, 0)

					-- explode hearts all over!
					-- heart ring:
					for i = 1, 8
						local h = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						h.state = S_LHRT
						h.fuse = TICRATE
						P_InstaThrust(h, (360/8 *i)*ANG1, FRACUNIT*32)
					end

					localquake(mo.battlen, FRACUNIT*30, 8)
					playSound(mo.battlen, sfx_pstop)

					for i = 1, 16
						local h = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						h.state = S_LHRT
						h.fuse = TICRATE
						h.momx = P_RandomRange(-24, 24)*FRACUNIT
						h.momy = P_RandomRange(-24, 24)*FRACUNIT
						h.momz = P_RandomRange(2, 24)*FRACUNIT
					end
				elseif timer == TICRATE*2
					return true
				end
			end,
}

attackDefs["lifeup1"] = {
		name = "Lifeup Alpha",				-- Name of the skill
		type = ATK_HEAL,				-- Type of the skill (does not stack like affinities)
		power = 50,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		norepel = true,
		costtype = CST_SP,		-- Cost type
		cost = 10,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Heals 50 HP to \none ally.",	-- Description
		nocast = false,
		target = TGT_ALLY,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 55
				playSound(mo.battlen, sfx_ebheal)
				damageObject(target, P_RandomRange(-37, -62))
				return true
			end
		end,
}

attackDefs["lifeup2"] = {
		name = "Lifeup Beta",				-- Name of the skill
		type = ATK_HEAL,				-- Type of the skill (does not stack like affinities)
		power = 50,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		norepel = true,
		costtype = CST_SP,		-- Cost type
		cost = 16,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Heals 50 HP to \none ally.",	-- Description
		nocast = false,
		target = TGT_ALLY,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 55
				playSound(mo.battlen, sfx_ebheal)
				damageObject(target, P_RandomRange(-37, -62))
				return true
			end
		end,
}

attackDefs["lifeup3"] = {
		name = "Lifeup Gamma",				-- Name of the skill
		type = ATK_HEAL,				-- Type of the skill (does not stack like affinities)
		power = 999,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		norepel = true,
		costtype = CST_SP,		-- Cost type
		cost = 26,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Fully heals \none ally.",	-- Description
		nocast = false,
		target = TGT_ALLY,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 55
				playSound(mo.battlen, sfx_ebheal)
				damageObject(target, P_RandomRange(-999))
				return true
			end
		end,
}

attackDefs["lifeup4"] = {
		name = "Lifeup Omega",				-- Name of the skill
		type = ATK_HEAL,				-- Type of the skill (does not stack like affinities)
		power = 250,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		norepel = true,
		costtype = CST_SP,		-- Cost type
		cost = 48,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Heals 250 HP to \nall allies.",	-- Description
		nocast = false,
		target = TGT_ALLALLIES,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			if timer == 55
				playSound(mo.battlen, sfx_ebheal)
				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target, P_RandomRange(-150, -250))
				end
				return true
			end
		end,
}

attackDefs["shield1"] = {
		name = "Shield Alpha",				-- Name of the skill
		type = ATK_HEAL,				-- Type of the skill (does not stack like affinities)
		power = 50,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		norepel = true,
		costtype = CST_SP,		-- Cost type
		cost = 10,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Heals 50 HP to \none ally.",	-- Description
		nocast = false,
		target = TGT_ALLY,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 55
				playSound(mo.battlen, sfx_ebheal)
				damageObject(target, P_RandomRange(-37, -62))
				return true
			end
		end,
}

attackDefs["healing2"] = {
		name = "Healing Beta",				-- Name of the skill
		type = ATK_HEAL,				-- Type of the skill (does not stack like affinities)
		power = 90,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 16,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Cures poison, dizziness, silence,\nbrainwashing, burning, poison,\n and freezing.",	-- Description
		target = TGT_ALLY,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)

			elseif timer == 55
				playSound(mo.battlen, sfx_ebhsta)
				
				return true
			end
		end,
}

attackDefs["rockin1"] = {
		name = "Rockin' Alpha",				-- Name of the skill
		type = ATK_PSY,				-- Type of the skill (does not stack like affinities)
		power = 90,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 20,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Psy damage to \nall enemies.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target, P_RandomRange(20, 60))
				end
				return true
			end
		end,
		
		critanim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebsmaa)
				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target, P_RandomRange(24, 72))
				end
				//Damage *1.2 + knockdown
				return true
			end
		end,
}

attackDefs["rockin2"] = {
		name = "Rockin' Beta",				-- Name of the skill
		type = ATK_PSY,				-- Type of the skill (does not stack like affinities)
		power = 90,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 28,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Psy damage to \nall enemies.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target, P_RandomRange(45, 135))
				end
				return true
			end
		end,
}

attackDefs["rockin3"] = {
		name = "Rockin' Gamma",				-- Name of the skill
		type = ATK_PSY,				-- Type of the skill (does not stack like affinities)
		power = 160,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 80,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Psy damage to \nall enemies.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target, P_RandomRange(80, 240))
				end
				return true
			end
		end,
}

attackDefs["rockin4"] = {
		name = "Rockin' Omega",				-- Name of the skill
		type = ATK_PSY,				-- Type of the skill (does not stack like affinities)
		power = 320,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 196,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Psy damage to \nall enemies.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target, P_RandomRange(160, 480))
				end
				return true
			end
		end,
}

attackDefs["fire1"] = {
		name = "Fire Alpha",				-- Name of the skill
		type = ATK_FIRE,				-- Type of the skill (does not stack like affinities)
		power = 40,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 12,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Fire damage to \nall enemies.\mSmall chance to inflict BURN.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type
		status = COND_BURN,
		statucshance = 10,

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 28
				playSound(mo.battlen, sfx_ebfir1)
			elseif timer == 38
				playSound(mo.battlen, sfx_ebfir2)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target, P_RandomRange(30, 50))
				end
				return true
			end
		end,
}

attackDefs["fire2"] = {
		name = "Fire Beta",				-- Name of the skill
		type = ATK_FIRE,				-- Type of the skill (does not stack like affinities)
		power = 80,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 24,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Fire damage to \nall enemies.\mSmall chance to inflict BURN.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type
		status = COND_BURN,
		statucshance = 10,

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 28
				playSound(mo.battlen, sfx_ebfir1)
			elseif timer == 38
				playSound(mo.battlen, sfx_ebfir2)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target, P_RandomRange(60, 100))
				end
				return true
			end
		end,
}

attackDefs["fire3"] = {
		name = "Fire Gamma",				-- Name of the skill
		type = ATK_FIRE,				-- Type of the skill (does not stack like affinities)
		power = 120,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 40,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Fire damage to \nall enemies.\mSmall chance to inflict BURN.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type
		status = COND_BURN,
		statucshance = 10,

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 28
				playSound(mo.battlen, sfx_ebfir1)
			elseif timer == 38
				playSound(mo.battlen, sfx_ebfir2)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target, P_RandomRange(90, 150))
				end
				return true
			end
		end,
}

attackDefs["fire4"] = {
		name = "Fire Omega",				-- Name of the skill
		type = ATK_FIRE,				-- Type of the skill (does not stack like affinities)
		power = 160,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 84,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Fire damage to \nall enemies.\mSmall chance to inflict BURN.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type
		status = COND_BURN,
		statucshance = 10,

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 28
				playSound(mo.battlen, sfx_ebfir1)
			elseif timer == 38
				playSound(mo.battlen, sfx_ebfir2)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				for i = 1,#hittargets
					local target = hittargets[i]
					damageObject(target, P_RandomRange(120, 200))
				end
				return true
			end
		end,
}

attackDefs["freeze1"] = {
		name = "Freeze Alpha",				-- Name of the skill
		type = ATK_ICE,				-- Type of the skill (does not stack like affinities)
		power = 90,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 16,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Freeze damage to \none enemy.",	-- Description
		target = TGT_ENEMY,				-- Target type

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 28
				playSound(mo.battlen, sfx_ebfre1)
			elseif timer == 46
				playSound(mo.battlen, sfx_ebfre2)
			elseif timer == 83
				playSound(mo.battlen, sfx_ebehur)
				damageObject(target, P_RandomRange(62, 117))
				return true
			end
		end,
}

attackDefs["freeze2"] = {
		name = "Freeze Beta",				-- Name of the skill
		type = ATK_ICE,				-- Type of the skill (does not stack like affinities)
		power = 90,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 18,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Freeze damage to \none enemy.",	-- Description
		target = TGT_ENEMY,				-- Target type

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 28
				playSound(mo.battlen, sfx_ebfre1)
			elseif timer == 46
				playSound(mo.battlen, sfx_ebfre2)
			elseif timer == 83
				playSound(mo.battlen, sfx_ebehur)
				damageObject(target, P_RandomRange(135, 225))
				return true
			end
		end,
}

attackDefs["freeze3"] = {
		name = "Freeze Gamma",				-- Name of the skill
		type = ATK_ICE,				-- Type of the skill (does not stack like affinities)
		power = 90,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 36,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Freeze damage to \none enemy.",	-- Description
		target = TGT_ENEMY,				-- Target type

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 28
				playSound(mo.battlen, sfx_ebfre1)
			elseif timer == 46
				playSound(mo.battlen, sfx_ebfre2)
			elseif timer == 83
				playSound(mo.battlen, sfx_ebehur)
				damageObject(target, P_RandomRange(202, 337))
				return true
			end
		end,
}

attackDefs["freeze4"] = {
		name = "Freeze Omega",				-- Name of the skill
		type = ATK_ICE,				-- Type of the skill (does not stack like affinities)
		power = 90,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 56,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Freeze damage to \none enemy.",	-- Description
		target = TGT_ENEMY,				-- Target type

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 28
				playSound(mo.battlen, sfx_ebfre1)
			elseif timer == 46
				playSound(mo.battlen, sfx_ebfre2)
			elseif timer == 83
				playSound(mo.battlen, sfx_ebehur)
				damageObject(target, P_RandomRange(270, 450))
				return true
			end
		end,
}

attackDefs["thunder1"] = {
		name = "Thunder Alpha",				-- Name of the skill
		type = ATK_ELEC,				-- Type of the skill (does not stack like affinities)
		power = 60,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 6,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Electric damage to \na random enemy.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type

		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[P_RandomRange(1, #hittargets)]
			
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				damageObject(target, P_RandomRange(30, 90))
				return true
			end
		end,
}

attackDefs["thunder2"] = {
		name = "Thunder Beta",				-- Name of the skill
		type = ATK_ELEC,				-- Type of the skill (does not stack like affinities)
		power = 60,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 14,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Electric damage to \ntwo random enemies.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local hit = P_RandomRange(1, #hittargets)
			local alreadytargetted = {
				[hit] = true
			}
			local target = hittargets[hit]
			local hitlist = {
			}
			
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				for i = 1,2
					repeat
						hit = P_RandomRange(1, #hittargets)
					until not alreadytargetted[hit]
					target = hittargets[hit]
					damageObject(target, P_RandomRange(30, 90))
				end
				return true
			end
		end,
}

attackDefs["thunder3"] = {
		name = "Thunder Gamma",				-- Name of the skill
		type = ATK_ELEC,				-- Type of the skill (does not stack like affinities)
		power = 100,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 14,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Electric damage to \nthree random enemies.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local hit = P_RandomRange(1, #hittargets)
			local alreadytargetted = {
				[hit] = true
			}
			local target = hittargets[hit]
			local hitlist = {
			}
			
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				for i = 1,3
					repeat
						hit = P_RandomRange(1, #hittargets)
					until not alreadytargetted[hit]
					target = hittargets[hit]
					damageObject(target, P_RandomRange(50, 150))
				end
				return true
			end
		end,
}

attackDefs["thunder4"] = {
		name = "Thunder Omega",				-- Name of the skill
		type = ATK_ELEC,				-- Type of the skill (does not stack like affinities)
		power = 100,						-- Power of the skill
		accuracy = 100,					-- Accuracy (%) of the skill
		costtype = CST_SP,		-- Cost type
		cost = 14,						-- Cost
		critical = 0,					-- Critical chance (%)
		desc = "Electric damage to \nfour random enemies.",	-- Description
		target = TGT_ALLENEMIES,				-- Target type

		-- animation (mobj_t caster, table of mobj_t original targets, table of mobj_t actual hit targets, tic_t timer)
		/*
			targets is the table of originally targetted enemies
			hittargets is the table of enemies that were actually hit (ie: repels)
			timer is just a variable that will keep counting up each frame to aid in animating your attacks

			The animation ends when the function returns true.
			Use 'damageObject(mobj_t)' to deal the damage to the target in your animation.

		*/

		anim = function(mo, targets, hittargets, timer)
			local hit = P_RandomRange(1, #hittargets)
			local alreadytargetted = {
				[hit] = true
			}
			local target = hittargets[hit]
			local hitlist = {
			}
			
			if timer == 1
				playSound(mo.battlen, sfx_ebpsi)
			elseif timer == 55
				playSound(mo.battlen, sfx_ebehur)
				for i = 1,4
					repeat
						hit = P_RandomRange(1, #hittargets)
					until not alreadytargetted[hit]
					target = hittargets[hit]
					damageObject(target, P_RandomRange(50, 150))
				end
				return true
			end
		end,
}