local function SafeFreeSlot(...)
	for _,slot in ipairs({...})
		if not rawget(_G, slot) freeslot(slot) end -- Ensure we don't accidentally overlap existing freeslots
	end
end
SafeFreeSlot("sfx_sdrown","sfx_sfall","sfx_sgener","sfx_2drown","sfx_2fall","sfx_2gener","sfx_agener","sfx_afall","sfx_adrown","S_PLAY_DROWNANIM","SPR2_DRW2","S_PLAY_DEATHANIM","SPR2_DEA2")
sfxinfo[sfx_sdrown].caption = 'Drowning'
sfxinfo[sfx_sfall].caption = '\x85"No!!"\x80'
sfxinfo[sfx_sgener].caption = '\x85"No!"\x80'
sfxinfo[sfx_2drown].caption = 'Drowning'
sfxinfo[sfx_2fall].caption = '\x85"Huehh!"\x80'
sfxinfo[sfx_2gener].caption = '\x85"No!"\x80'
sfxinfo[sfx_adrown].caption = 'Drowning'
sfxinfo[sfx_afall].caption = '\x82"Woahhh!"\x80'
sfxinfo[sfx_agener].caption = '\x82"Oh no!"\x80'

states[S_PLAY_DROWNANIM] = {
	sprite = SPR_PLAY,
	frame = A|SPR2_DRW2|FF_ANIMATE,
	tics = punchlenght,
	var1 = 3,
	var2 = 4,
	nextstate = S_PLAY_PUNCH
}
spr2defaults[SPR2_DRW2] = SPR2_CNT1
states[S_PLAY_DEATHANIM] = {
	sprite = SPR_PLAY,
	frame = A|SPR2_DEA2|FF_ANIMATE,
	tics = punchlenght,
	var1 = 3,
	var2 = 4,
	nextstate = S_PLAY_PUNCH
}
spr2defaults[SPR2_DEA2] = SPR2_CNT1

addHook("MobjDeath", function(mobj, inflictor, source, damageType)
	if mobj.skin == "kombi"
		mobj.player.diedto = 1
		if damageType == DMG_DEATHPIT
			if P_RandomChance(3*FRACUNIT/4)
				S_StartSound(mobj,sfx_sfall)
			else
				S_StartSound(mobj,sfx_2fall)
			end
		elseif damageType == DMG_DROWNED or damageType == DMG_SPACEDROWN
			mobj.player.diedto = 1 << 2
			if P_RandomChance(3*FRACUNIT/4)
				S_StartSound(mobj,sfx_sdrown)
			else
				S_StartSound(mobj,sfx_2drown)
			end
		else
			mobj.player.diedto = 1 << 1
			if P_RandomChance(3*FRACUNIT/4)
				S_StartSound(mobj,sfx_sgener)
			else
				S_StartSound(mobj,sfx_2gener)
			end
		end
		return true
	end
	if mobj.skin == "shyne"
		if damageType == DMG_DEATHPIT
			mobj.player.diedto = 1
			S_StartSound(mobj,sfx_afall)
		elseif damageType == DMG_DROWNED or damageType == DMG_SPACEDROWN
			mobj.player.diedto = 1 << 2
			S_StartSound(mobj,sfx_adrown)
		else
			mobj.player.diedto = 1 << 1
			S_StartSound(mobj,sfx_2gener)
		return true
		end
	end
	if mobj.skin == "trez"
		if damageType == DMG_DEATHPIT
			mobj.player.diedto = 1
			S_StartSound(mobj,sfx_afall)
		elseif damageType == DMG_DROWNED or damageType == DMG_SPACEDROWN
			mobj.player.diedto = 1 << 2
			S_StartSound(mobj,sfx_adrown)
		else
			mobj.player.diedto = 1 << 1
			S_StartSound(mobj,sfx_agener)
		return true
		end
	end
	if player.diedto >= 2
		if player.diedto >= 4 then player.mo.state = S_PLAY_DROWNANIM else player.mo.state = S_PLAY_DEATHANIM end
	elseif player.diedto >= 1 and P_CheckDeathPitCollide(player.mo)
		player.mo.flags = $|MF_NOCLIPHEIGHT
		player.mo.state = S_PLAY_FALL
	end
end, MT_PLAYER)

addHook("ThinkFrame", function()
	for player in players.iterate
		if player.playerstate == PST_DEAD and kombiwhogetswl4stuff[player.realmo.skin] --simplify by doing all wl4 chars, considering only the important chars get variables written to up above no conflicts should occur
			if player.diedto player.mo.flags2 = $&~MF2_DONTDRAW end -- Why do you get set.
			if player.diedto >= 2
				if player.diedto >= 4 then player.mo.state = S_PLAY_DROWNANIM else player.mo.state = S_PLAY_DEATHANIM end
			elseif player.diedto >= 1 and P_CheckDeathPitCollide(player.mo)
				player.mo.flags = $|MF_NOCLIPHEIGHT
				player.mo.state = S_PLAY_FALL
			end
		end
	end
end)